﻿using DevExpress.XtraBars.Localization;
using DevExpress.XtraEditors;
using DevExpress.XtraRichEdit.Import.Html;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace NewArchivesCenter
{
    public partial class AddNewLog : DevExpress.XtraEditors.XtraUserControl
    {
        public AddNewLog()
        {
            InitializeComponent();
            labelControl7.Text = textEdit1.Text;
            labelControl8.Text = dateEdit1.Text;
            labelControl9.Text = textEdit2.Text;
        }

        private void simpleButton1_Click_1(object sender, EventArgs e)
        {
            if (dateEdit1.Text != null)
            {
                DateTime selectedDateTime = dateEdit1.DateTime;
                int year = selectedDateTime.Year;
                int month = selectedDateTime.Month;
                int day = selectedDateTime.Day;
                string yearString = year.ToString();
                string monthString = month.ToString();
                string dayString = day.ToString();
                if (!File.Exists(Path.GetTempPath() + @"ArchivesCenter\Data\" + Properties.Settings.Default.current_user + @"\" + yearString + @"\" + monthString + @"\" + selectedDateTime.ToString("D") + @"\LogInfo.actxt"))
                {
                    Directory.CreateDirectory(Path.GetTempPath() + @"ArchivesCenter\Data\" + Properties.Settings.Default.current_user + @"\" + yearString + @"\" + monthString + @"\" + selectedDateTime.ToString("D"));
                    using (StreamWriter writer = new StreamWriter(Path.GetTempPath() + @"ArchivesCenter\Data\" + Properties.Settings.Default.current_user + @"\" + yearString + @"\" + monthString + @"\" + selectedDateTime.ToString("D") + @"\LogInfo.actxt"))
                    {
                        writer.WriteLine(textEdit1.Text);
                        writer.WriteLine(selectedDateTime.ToString("D"));
                        writer.WriteLine(textEdit2.Text);
                    }
                    gridControlExtension1.CurrentPath = Path.GetTempPath() + @"ArchivesCenter\Data\" + Properties.Settings.Default.current_user + @"\" + yearString + @"\" + monthString + @"\" + selectedDateTime.ToString("D") + @"\";
                    gridControlExtension1.RefreshData();
                    simpleButton1.Enabled = false;
                    simpleButton2.Enabled = true;
                    simpleButton4.Enabled = true;
                    simpleButton3.Enabled = false;
                    textEdit1.ReadOnly = true;
                    textEdit2.ReadOnly = true;
                    dateEdit1.ReadOnly = true;
                    richEdit1.Enabled = true;
                    gridControl1.Enabled = true;
                    labelControl10.Visible = true;
                }
                else
                {
                    File.Delete(Path.GetTempPath() + @"ArchivesCenter\Data\" + Properties.Settings.Default.current_user + @"\" + yearString + @"\" + monthString + @"\" + selectedDateTime.ToString("D") + @"\" + "LogInfo.actxt");
                    using (StreamWriter writer = new StreamWriter(Path.GetTempPath() + @"ArchivesCenter\Data\" + Properties.Settings.Default.current_user + @"\" + yearString + @"\" + monthString + @"\" + selectedDateTime.ToString("D") + @"\LogInfo.actxt"))
                    {
                        writer.WriteLine(textEdit1.Text);
                        writer.WriteLine(selectedDateTime.ToString("D"));
                        writer.WriteLine(textEdit2.Text);
                    }
                    simpleButton1.Enabled = false;
                    simpleButton3.Enabled = false;
                    labelControl10.Visible = false;
                    richEdit1.Enabled = true;
                    gridControl1.Enabled = true;
                    simpleButton2.Enabled = true;
                    simpleButton4.Enabled = true;
                }
            }
            else
            {
                MessageBox.Show("请输入时间", "Archives Center", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }

        private void simpleButton3_Click(object sender, EventArgs e)
        {
            textEdit2.Text = Properties.Settings.Default.current_user;
        }

        private void simpleButton4_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show("删除操作不可逆，请慎重操作。\n确认删除日志？","Archives Center 删除确认",MessageBoxButtons.YesNo,MessageBoxIcon.Question) == DialogResult.Yes)
            {
                DateTime selectedDateTime = dateEdit1.DateTime;
                int year = selectedDateTime.Year;
                int month = selectedDateTime.Month;
                int day = selectedDateTime.Day;
                string yearString = year.ToString();
                string monthString = month.ToString();
                string dayString = day.ToString();
                string[] files = Directory.GetFiles(Path.GetTempPath() + @"ArchivesCenter\Data\" + Properties.Settings.Default.current_user + @"\" + yearString + @"\" + monthString + @"\" + selectedDateTime.ToString("D"));
                foreach (string file in files)
                    File.Delete(file.ToString());
                Directory.Delete(Path.GetTempPath() + @"ArchivesCenter\Data\" + Properties.Settings.Default.current_user + @"\" + yearString + @"\" + monthString + @"\" + selectedDateTime.ToString("D"));
                simpleButton2.Enabled = false;
                simpleButton5.Enabled = false;
                simpleButton4.Enabled = false;
                simpleButton3.Enabled = true;
                simpleButton1.Enabled = true;
                textEdit1.ReadOnly = false;
                textEdit2.ReadOnly = false;
                dateEdit1.ReadOnly = false;
                textEdit1.Text = null;
                textEdit2.Text = null;
                dateEdit1.Text = null;
                richEdit1.Enabled = false;
                gridControl1.Enabled = false;
                labelControl7.Text = textEdit1.Text;
                labelControl8.Text = dateEdit1.Text;
                labelControl9.Text = textEdit2.Text;
                labelControl10.Visible = false;
                labelControl11.Text = "删除操作成功！";
            }
        }

        private void textEdit1_EditValueChanged(object sender, EventArgs e)
        {
            labelControl7.Text = textEdit1.Text;
        }

        private void simpleButton2_Click(object sender, EventArgs e)
        {
            simpleButton5.Enabled = true;
            simpleButton2.Enabled = false;
            richEdit1.Enabled = false;
            gridControl1.Enabled = false;
            labelControl11.Text = "确认成功！";
        }

        private void dateEdit1_EditValueChanged(object sender, EventArgs e)
        {
            DateTime selectedDateTime = dateEdit1.DateTime;
            int year = selectedDateTime.Year;
            int month = selectedDateTime.Month;
            int day = selectedDateTime.Day;
            string yearString = year.ToString();
            string monthString = month.ToString();
            string dayString = day.ToString();
            labelControl8.Text = dateEdit1.DateTime.ToString("D");
            if (File.Exists(Path.GetTempPath() + @"ArchivesCenter\Data\" + Properties.Settings.Default.current_user + @"\" + yearString + @"\" + monthString + @"\" + selectedDateTime.ToString("D") + @"\LogInfo.actxt"))
            {
                MessageBox.Show("检测到当前时间下已存在日志", "Archives Center", MessageBoxButtons.OK, MessageBoxIcon.Information);
                string labelControl12 = Properties.Settings.Default.current_user + @"\" + yearString + @"\" + monthString + @"\" + selectedDateTime.ToString("D");
                using (StreamReader sr = new StreamReader(Path.GetTempPath() + @"ArchivesCenter\Data\" + labelControl12 + @"\" + "LogInfo.actxt"))
                {
                    string firstLine = sr.ReadLine();
                    textEdit1.Text = firstLine;
                    labelControl7.Text = textEdit1.Text;
                    string secondLine = sr.ReadLine();
                    string thirdLine = sr.ReadLine();
                    textEdit2.Text = thirdLine;
                    labelControl9.Text = textEdit2.Text;
                }
                richEdit1.richEditControl1.LoadDocument(Path.GetTempPath() + @"ArchivesCenter\Data\" + labelControl12 + @"\" + "content.acdoc");
                gridControlExtension1.CurrentPath = Path.GetTempPath() + @"ArchivesCenter\Data\" + labelControl12 + @"\";
            }
        }

        private void textEdit2_EditValueChanged(object sender, EventArgs e)
        {
            labelControl9.Text = textEdit2.Text;
        }

        private void simpleButton5_Click(object sender, EventArgs e)
        {
            DateTime selectedDateTime = dateEdit1.DateTime;
            int year = selectedDateTime.Year;
            int month = selectedDateTime.Month;
            int day = selectedDateTime.Day;
            string yearString = year.ToString();
            string monthString = month.ToString();
            string dayString = day.ToString();
            if (File.Exists(Path.GetTempPath() + @"ArchivesCenter\Data\" + Properties.Settings.Default.current_user + @"\" + yearString + @"\" + monthString + @"\" + selectedDateTime.ToString("D") + @"\content.acdoc"))
                File.Delete(Path.GetTempPath() + @"ArchivesCenter\Data\" + Properties.Settings.Default.current_user + @"\" + yearString + @"\" + monthString + @"\" + selectedDateTime.ToString("D") + @"\content.acdoc");
            richEdit1.richEditControl1.SaveDocument(Path.GetTempPath() + @"ArchivesCenter\Data\" + Properties.Settings.Default.current_user + @"\" + yearString + @"\" + monthString + @"\" + selectedDateTime.ToString("D") + @"\content.acdoc", DevExpress.XtraRichEdit.DocumentFormat.Doc);
            labelControl11.Text = "成功！";
            simpleButton5.Enabled = false;
        }
    }
}
