﻿using DevExpress.XtraEditors;
using DevExpress.XtraRichEdit.Export;
using DevExpress.XtraRichEdit;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace NewArchivesCenter
{
    public partial class RichEdit : DevExpress.XtraEditors.XtraUserControl
    {
        public RichEdit()
        {
            InitializeComponent();
        }

        private void barButtonItem1_ItemClick(object sender, DevExpress.XtraBars.ItemClickEventArgs e)
        {
            if(saveFileDialog1.ShowDialog()== DialogResult.OK)
            {
                richEditControl1.SaveDocument(saveFileDialog1.FileName, DocumentFormat.Doc);
            }
        }

        private void richEditControl1_BeforeExport(object sender, DevExpress.XtraRichEdit.BeforeExportEventArgs e)
        {
            DocumentExportCapabilities checkDocument = richEditControl1.Document.RequiredExportCapabilities;
            if ((e.DocumentFormat == DocumentFormat.Rtf) && checkDocument.InlinePictures)
            {
                DialogResult reduceFileSize = MessageBox.Show("此文档包含内联图片。\n您可以将同一张图片嵌入到两种不同类型的 （原始图片和 Windows 图元文件） 中，以获得更好的兼容性，尽管这会增加文件大小。默认情况下，图片仅以原始格式保存。\n在保存的文件中启用双图片格式？",
                "警告", MessageBoxButtons.YesNo, MessageBoxIcon.Warning);
                RtfDocumentExporterOptions options = e.Options as RtfDocumentExporterOptions;
                if (options != null)
                {
                    switch (reduceFileSize)
                    {
                        case DialogResult.Yes:
                            options.Compatibility.DuplicateObjectAsMetafile = true;
                            break;
                        case DialogResult.No:
                            options.Compatibility.DuplicateObjectAsMetafile = false;
                            break;
                    }
                }
            }
        }
    }
}
